; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    bubble_sort PROTO :DWORD,:DWORD

    .data?
      value dd ?

    .data
      narr dd 1,9,2,8,3,7,4,6,5,0   ; 10 unsorted numbers

    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    push ebx
    push esi

    print "Unsorted",13,10

    mov esi, OFFSET narr
    mov ebx, LENGTHOF narr

  @@:
    print str$([esi]),13,10
    add esi, 4
    sub ebx, 1
    jnz @B

    invoke bubble_sort,OFFSET narr,LENGTHOF narr

    print chr$(13,10)
    print "Sorted",13,10

    mov esi, OFFSET narr
    mov ebx, LENGTHOF narr

  @@:
    print str$([esi]),13,10
    add esi, 4
    sub ebx, 1
    jnz @B


    pop esi
    pop ebx

    ret

main endp

; 

bubble_sort proc parr:DWORD,cnt:DWORD

    push ebx
    push esi

    sub cnt, 1                  ; set count to 1 less than member count

  lbl0:
    mov esi, parr               ; load array into ESI
    xor edx, edx                ; zero the changed flag
    mov ebx, cnt                ; set the loop counter for member count

  lbl1:
    mov eax, [esi]              ; load first pair of numbers in array
    mov ecx, [esi+4]
    cmp eax, ecx                ; compare which is higher
    jl lbl2                     

    mov [esi], ecx              ; swap if 1st number is higher
    mov [esi+4], eax
    mov edx, 1                  ; set the changed flag

  lbl2:
    add esi, 4                  ; step up one to compare next pair
    sub ebx, 1                  ; decrement the counter
    jnz lbl1

    test edx, edx               ; test if the changed flag is set.
    jnz lbl0                    ; loop back if it is

    pop esi
    pop ebx

    ret

bubble_sort endp

; 

end start
